//---------------------------------------------------------------------------
#include "pch.h"
#pragma hdrstop

#include "qtMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner), qtGrafport(0), qtController(0)
{
	if ( InitializeQTML(0) != noErr || EnterMovies() != noErr )
	{ // darn
		::MessageBox( NULL, "Error initializing QT", "QT ERROR", MB_OK );
	}
	Application->OnMessage = AppOnMessage;
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1()
{
	ExitMovies();
	TerminateQTML();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
	if ( qtGrafport == NULL )
	{ // Associate panel with QT
		qtGrafport = (CGrafPtr)CreatePortAssociation( Handle, NULL, 0 );
	}

	if ( qtController )
		DisposeMovieController(qtController);

	// Use QT for file selection with preview
	StandardFileReply qtReply;
	StandardGetFilePreview( 0, -1, 0, &qtReply );
	
	if ( qtReply.sfGood )
	{ // didn't cancel, so transform it to QT file
		
		SetGWorld( qtGrafport, NULL );

		short movieRefNum;
		if ( OpenMovieFile( &qtReply.sfFile, &movieRefNum, fsRdPerm ) != noErr )
		{ // oops
			AnsiString emsg = "Error opening movie file: ";
			emsg = emsg + (char*)qtReply.sfFile.name;
			MessageBox( NULL, emsg.c_str(), "QT Error", MB_OK );
		}
		else if ( NewMovieFromFile( &QTMovie, movieRefNum, 0,0, newMovieActive, 0 ) != noErr )
		{ // unable to create movie from file
			MessageBox( NULL, "Unable to create movie", "QT Error", MB_OK );
		}
		else
		{ // okay to here, close the file
			CloseMovieFile(movieRefNum);
		}

		Rect cRect;
		cRect.top = static_cast<short>(ClientRect.Top);
		cRect.left = static_cast<short>(ClientRect.Left);
		cRect.bottom = static_cast<short>(ClientRect.Bottom);
		cRect.right = static_cast<short>(ClientRect.Right);
		qtController = NewMovieController( QTMovie, &cRect, 0 );
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
	if ( qtController )
		DisposeMovieController(qtController);

	if ( qtGrafport )
		DestroyPortAssociation( qtGrafport );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::WndProc(Messages::TMessage &Message)
{
#if !defined(USE_APP_ON_MSG)
	if ( qtController )
	{ // QuickTime is running. so hand it the events
		MSG Msg;

		Msg.hwnd = Handle;
		Msg.message = Message.Msg;
		Msg.wParam = Message.WParam;
		Msg.lParam = Message.LParam;

		Msg.time = GetMessageTime();             // Get time of message

		DWORD msgPos = GetMessagePos();          // Get mouse position
		Msg.pt.x = LOWORD(msgPos);               // Extract x coordinate
		Msg.pt.y = HIWORD(msgPos);               // Extract y coordinate
        
		EventRecord qtmlEvt;		// Macintosh event record
		NativeEventToMacEvent(&Msg, &qtmlEvt);  // Convert to event
		MCIsPlayerEvent (qtController, &qtmlEvt);  // Pass event to QuickTime
	}
#endif
	
	TForm::WndProc(Message);
}

//---------------------------------------------------------------------------

void __fastcall TForm1::AppOnMessage(TMsg &Msg, bool &Handled)
{
#if defined(USE_APP_ON_MSG)
	if ( qtController )
	{ // Give QuickTime a crack at it

		EventRecord qtmlEvt;		// Macintosh event record
		NativeEventToMacEvent(&Msg, &qtmlEvt);  // Convert to event

		if ( Msg.message == WM_PAINT )
		{
			Handled = true;
		}
		else
			Handled = false;
			
		MCIsPlayerEvent (qtController, &qtmlEvt);  // Pass event to QuickTime
	}
	else
		Handled = false;
#endif
}

 